--- src/backend/storage/buffer/buf_async.c.orig	2014-08-19 10:17:32.822616336 -0400
+++ src/backend/storage/buffer/buf_async.c	2014-08-19 16:56:13.535196628 -0400
@@ -0,0 +1,1203 @@
+/*-------------------------------------------------------------------------
+ *
+ * buf_async.c
+ *	  buffer manager asynchronous disk read routines
+ *
+ * Portions Copyright (c) 1996-2012, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ *
+ * IDENTIFICATION
+ *	  src/backend/storage/buffer/buf_async.c
+ *
+ *-------------------------------------------------------------------------
+ */
+/*
+ * Principal entry points:
+ *
+ * BufStartAsync() -- start an asynchronous read of a block into a buffer and
+ *	 pin it so that no one can destroy it while this process is using it.
+ *
+ * BufCheckAsync() -- check completion of an asynchronous read
+ *       and either claim buffer or discard it
+ *
+ * Private helper
+ *
+ * BufReleaseAsync() -- release the BAiocb resources used for an asynchronous read
+ *
+ * See also these files:
+ *		bufmgr.c -- main buffer manager functions
+ *		buf_init.c -- initialisation of resources
+ */
+#include "postgres.h"
+#include <sys/types.h> 
+#include <sys/file.h>
+#include <unistd.h>
+#include <sched.h>
+
+#include "catalog/catalog.h"
+#include "common/relpath.h"
+#include "executor/instrument.h"
+#include "miscadmin.h"
+#include "pg_trace.h"
+#include "pgstat.h"
+#include "postmaster/bgwriter.h"
+#include "storage/buf_internals.h"
+#include "storage/bufmgr.h"
+#include "storage/ipc.h"
+#include "storage/proc.h"
+#include "storage/smgr.h"
+#include "storage/standby.h"
+#include "utils/rel.h"
+#include "utils/resowner_private.h"
+
+/*
+ * GUC parameters
+ */
+int      max_async_io_prefetchers; /* Maximum number of backends using asynchronous librt threads to read pages into our buffers */
+
+#if defined(USE_AIO_SIGEVENT)
+long num_startedaio = 0;
+long num_cancelledaio = 0;
+long num_signalledaio = 0;                  /* count of number of signals delivered - counted by handlaiosignal */
+unsigned long BAiocbaioOrdinal = 0;    /* ordinal of most recent aio originated by me */
+#endif /*  USE_AIO_SIGEVENT   && defined(COUNT_QUEUED_SIGNALS)  */
+
+/* Note: these two macros only work on shared buffers, not local ones! */
+#define BufHdrGetBlock(bufHdr)	((Block) (BufferBlocks + ((Size) (bufHdr)->buf_id) * BLCKSZ))
+#define BufferGetLSN(bufHdr)	(PageGetLSN(BufHdrGetBlock(bufHdr)))
+
+extern volatile struct BAiocbAnchor *BAiocbAnchr;  /*  anchor for all control blocks pertaining to aio  */
+extern int numBufferAiocbs;        /*  total number of  BufferAiocbs in pool  */
+extern int maxGetBAiocbTries;      /*   max times we will try to get a free BufferAiocb */
+extern int maxRelBAiocbTries;      /*   max times we will try to release a BufferAiocb back to freelist */
+extern pid_t this_backend_pid;     /*   pid of this backend */
+
+extern bool PinBuffer(volatile BufferDesc *buf, BufferAccessStrategy strategy);
+extern void PinBuffer_Locked(volatile BufferDesc *buf);
+extern Buffer ReadBuffer_common(SMgrRelation reln, char relpersistence,
+				  ForkNumber forkNum, BlockNumber blockNum,
+				  ReadBufferMode mode, BufferAccessStrategy strategy,
+				  bool *hit , int index_for_aio);
+extern void UnpinBuffer(volatile BufferDesc *buf, bool fixOwner);
+extern void TerminateBufferIO(volatile BufferDesc *buf, bool clear_dirty,
+				  int set_flag_bits);
+int BufCheckAsync(SMgrRelation caller_smgr, Relation caller_reln, volatile BufferDesc *buf_desc
+  ,int intention , BufferAccessStrategy strategy , int index_for_aio , bool spinLockHeld , LWLockId PartitionLock );
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+int BufStartAsync(Relation reln, ForkNumber forkNum, BlockNumber blockNum , BufferAccessStrategy strategy);
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on signal instead of polling */
+/*   PoorMans atomics forward decls */
+static int PoorMLock(volatile int *intP);
+static int PoorMUnLock(volatile int *intP);
+static int PoorMIncr(volatile int *intP);
+static int PoorMDecr(volatile int *intP);
+void BufPostAioWaiters(struct BufferAiocb volatile * BAiocb);
+void BufHandlSigAsync(int sigsent, siginfo_t * siginfP, void *ucontext);
+int BufAWaitAioCompletion (struct BufferAiocb *BAiocb);
+#endif  /* USE_AIO_SIGEVENT    */
+
+static struct BufferAiocb volatile * cachedBAiocb = (struct BufferAiocb*)0;  /*  one cached BufferAiocb for use with aio */
+
+/*  BufReleaseAsync releases a BufferAiocb and returns 0 if successful else non-zero
+**  it *must* be called :
+**     EITHER with a valid  BAiocb->BAiocbbufh -> buf_desc
+**            and that buf_desc must be spin-locked
+**     OR     with BAiocb->BAiocbbufh == 0
+*/
+static int
+BufReleaseAsync(struct BufferAiocb volatile * BAiocb)
+{
+        int    LockTries;         /*  max times we will try to release the BufferAiocb */
+        volatile struct BufferAiocb *BufferAiocbs;
+        struct BufferAiocb volatile * oldFreeBAiocb;  /*  old value of FreeBAiocbs */
+
+        int failed = 1; /* by end of this function, non-zero  will indicate if we failed to return the BAiocb */
+
+
+        if (    ( BAiocb == (struct BufferAiocb*)0 )
+             || ( BAiocb == (struct BufferAiocb*)BAIOCB_OCCUPIED )
+             || ( ((unsigned long)BAiocb) & 0x1 )
+           ) {
+                          elog(ERROR,
+                                 "AIO control block corruption on release of aiocb %p - invalid BAiocb"
+                                          ,BAiocb);
+        }
+        else 
+        if (   (0 == BAiocb->BAiocbDependentCount)     /*  no dependents  */
+            && ((struct BufferAiocb*)BAIOCB_OCCUPIED == BAiocb->BAiocbnext)  /*  not already on freelist */
+           ) {
+
+            if ((struct sbufdesc*)0 != BAiocb->BAiocbbufh) { /*  if a buffer was attached */
+                volatile        BufferDesc *buf_desc = BAiocb->BAiocbbufh;
+
+                /*  spinlock held so instead of TerminateBufferIO(buf, false , 0); ... */
+                if (buf_desc->flags & BM_AIO_PREFETCH_PIN_BANKED) { /* if a pid banked the pin */
+                    buf_desc->freeNext = -(BAiocb->pidOfAio);       /* then remember which pid */
+                }
+                else if (buf_desc->freeNext <= FREENEXT_BAIOCB_ORIGIN) {
+                    buf_desc->freeNext = FREENEXT_NOT_IN_LIST;   /* disconnect BufferAiocb from buf_desc */
+                }
+                buf_desc->flags &= ~BM_AIO_IN_PROGRESS;
+            }
+            
+            BAiocb->BAiocbbufh = (struct sbufdesc *)0; /* disconnect buf_desc from BufferAiocb */
+            BAiocb->pidOfAio = 0;                      /*  clean */
+            LockTries = maxRelBAiocbTries;         /*  max times we will try to release the BufferAiocb */
+            do {
+                register long long int dividend , remainder;
+
+                /*      retrieve old value of FreeBAiocbs  */
+                BAiocb->BAiocbnext = oldFreeBAiocb = BAiocbAnchr->FreeBAiocbs;  /*  old value of FreeBAiocbs */
+
+                /*  this is a volatile value unprotected by any lock,  so must validate it;
+                **  safest is to verify that it is identical to one of the BufferAiocbs
+                **  to do so,  verify by direct division that its address offset from first control block 
+                **  is an integral multiple of the control block size
+                **  that lies within the range [ 0 , (numBufferAiocbs-1) ]
+                */
+                BufferAiocbs = BAiocbAnchr->BufferAiocbs;
+                remainder = ((long long int)oldFreeBAiocb - (long long int)BufferAiocbs)
+                            % (long long int)(sizeof(struct BufferAiocb));
+                failed = (int)remainder;
+                if (!failed) {
+                    dividend = ((long long int)oldFreeBAiocb - (long long int)BufferAiocbs)
+                               / (long long int)(sizeof(struct BufferAiocb));
+                     failed = ( (dividend < 0 ) || ( dividend >= numBufferAiocbs) );
+                     if (!failed) {
+                         if (__sync_bool_compare_and_swap (&(BAiocbAnchr->FreeBAiocbs), oldFreeBAiocb, BAiocb)) {
+                            LockTries = 0;   /*  end the do loop  */
+
+                            goto cheering;   /*  cant simply break because then failed would be set incorrectly */
+                         }
+                    }
+                }
+                /*  if we reach here, we have failed and failed is set to -1 */
+
+       cheering: ;
+
+                if ( LockTries > 1 ) {
+                    sched_yield();    /*   yield to another process,  (hopefully a backend) */
+                }
+            } while  (LockTries-- > 0);
+
+            if (failed) {
+#ifdef LOG_RELBAIOCB_DEPLETION
+                          elog(LOG,
+                                "BufReleaseAsync:AIO control block %p unreleased after tries= %d\n"
+                                       ,BAiocb,maxRelBAiocbTries);
+#endif  /* LOG_RELBAIOCB_DEPLETION */
+            }
+
+        }
+              else
+                          elog(LOG,
+                                "BufReleaseAsync:AIO control block %p either has dependents= %d or is already on freelist %p or has no buf_header %p\n"
+                                       ,BAiocb , BAiocb->BAiocbDependentCount , BAiocb->BAiocbnext , BAiocb->BAiocbbufh);
+        return failed;
+}
+
+/*  try using asynchronous aio_read to prefetch into a buffer
+**  return code :
+**        0 if started successfully
+**       -1 if failed for some reason
+**        1+PrivateRefCount if we found desired buffer in buffer pool
+**
+**  There is a harmless race condition here :
+**  two different backends may both arrive here simultaneously
+**  to prefetch the same buffer.    This is not unlikely when a syncscan is in progress.
+**  .  One will acquire the buffer and issue the smgrstartaio
+**  .  Other will find the buffer on return from  ReadBuffer_common with hit = true
+**  Only the first task has a pin on the buffer since ReadBuffer_common knows not to get a pin
+**  on a found buffer in prefetch mode.
+**  Therefore  -   the second task must simply abandon the prefetch if it finds the buffer in the buffer pool.
+**
+**  if we fail to acquire a BAiocb because of concurrent theft from freelist by other backend,
+**  retry up to maxGetBAiocbTries times provided that there actually was at least one BAiocb on the freelist.
+*/
+int
+BufStartAsync(Relation reln, ForkNumber forkNum, BlockNumber blockNum , BufferAccessStrategy strategy) {
+
+        int retcode = -1;
+        struct BufferAiocb volatile * prevBAiocb;  /*  previous BufferAiocb in cachedchain */
+        struct BufferAiocb volatile * BAiocb = (struct BufferAiocb*)0;  /*  BufferAiocb for use with aio */
+        int  smgrstartaio_rc = -1;           /*  retcode from smgrstartaio */
+        bool do_unpin_buffer = false;        /* unpin must be deferred until after buffer descriptor is unlocked */
+        Buffer		buf_id;
+        bool		hit = false;
+        volatile        BufferDesc *buf_desc = (BufferDesc *)0;
+
+        int    LockTries;         /*  max times we will try to get a free BufferAiocb */
+
+        struct BufferAiocb volatile * oldFreeBAiocb;  /*  old value of FreeBAiocbs */
+        struct BufferAiocb volatile * newFreeBAiocb;  /*  new value of FreeBAiocbs */
+
+
+    /*  return immediately if no async io resources */
+    if (numBufferAiocbs > 0) {
+        buf_id = (Buffer)0;
+
+        if ( (struct BAiocbAnchor *)0 != BAiocbAnchr ) {
+
+            volatile struct BufferAiocb *BufferAiocbs;
+
+            prevBAiocb = (struct BufferAiocb*)(&cachedBAiocb); /*  prev points to BAiocb */
+            BAiocb = cachedBAiocb;      /* tentatively try the first if there is one */
+            if ((struct BufferAiocb*)0 != BAiocb) {  /* any usable cached BufferAiocb ? */
+                prevBAiocb->BAiocbnext = BAiocb->BAiocbnext;  /* unchain from cached chain */
+                BAiocb->BAiocbnext = (struct BufferAiocb*)BAIOCB_OCCUPIED; /* mark as not on freelist */
+                BAiocb->BAiocbDependentCount = 0;  /* no dependent yet */
+                BAiocb->BAiocbbufh = (struct sbufdesc*)0;
+                BAiocb->pidOfAio = 0;
+            } else {
+
+                LockTries = maxGetBAiocbTries;         /*  max times we will try to get a free BufferAiocb */
+                do {
+                    register long long int dividend = -1 , remainder;
+                    /*  check if we have a free BufferAiocb */
+
+                    oldFreeBAiocb = BAiocbAnchr->FreeBAiocbs;  /*  old value of FreeBAiocbs */
+
+                    /*  check if we have a free BufferAiocb */
+
+                    /*  BAiocbAnchr->FreeBAiocbs is a volatile value unprotected by any lock,
+                    **  and use of compare-and-swap to add and remove items from the list has
+                    **  two potential pitfalls,    both relating to the fact that we must
+                    **  access data de-referenced from this pointer before the compare-and-swap.
+                    **  1)  The value we load may be corrupt,  e.g. mixture of bytes from
+                    **      two different values,   so must validate it;
+                    **      safest is to verify that it is identical to one of the BufferAiocbs.
+                    **      to do so,  verify by direct division that its address offset from
+                    **      first control block is an integral multiple of the control block size
+                    **      that lies within the range [ 0 , (numBufferAiocbs-1) ]
+                    **      Thus we completely prevent this pitfall.
+                    **  2)  The content of the item's next pointer may have changed between the
+                    **      time we de-reference it and the time of the compare-and-swap.
+                    **      Thus even though the compare-and-swap succeeds,   we might set the
+                    **      new head of the freelist to an invalid value  (either a free item
+                    **      that is not the first in the free chain  -  resulting only in
+                    **      loss of the orphaned free items, or,  much worse, an in-use item).
+                    **      In practice this is extremely unlikely because of the implied huge delay
+                    **      in this window interval in this (current) process.    Here are two scenarios:
+                    **      legend:
+                    **         P0  -  this (current) process,  P1,  P2 , ... other processes
+                    **         content of freelist shown as BAiocbAnchr->FreeBAiocbs -> first item -> 2nd item ...
+                    **         @[X] means address of X
+                    **         |      timeline of window of exposure to problems
+                    **      successive lines in chronological order                                       content of freelist
+                    **        2.1    P0           access oldFreeBAiocb = BAiocbAnchr->FreeBAiocbs = @[I0]  F -> I0 -> I1 -> I2 -> I3 ...
+                    **               P0          access newFreeBAiocb = oldFreeBAiocb->BAiocbnext = @[I1]  F -> I0 -> I1 -> I2 -> I3 ...
+                    **         |        P1        access oldFreeBAiocb = BAiocbAnchr->FreeBAiocbs = @[I0]  F -> I0 -> I1 -> I2 -> I3 ...
+                    **         |        P1       access newFreeBAiocb = oldFreeBAiocb->BAiocbnext = @[I1]  F -> I0 -> I1 -> I2 -> I3 ...
+                    **         |        P1        swap-remove I0,  place I1 at head of list                F -> I1 -> I2 -> I3 ...
+                    **         |           P2     access oldFreeBAiocb = BAiocbAnchr->FreeBAiocbs = @[I1]  F -> I1 -> I2 -> I3 ...
+                    **         |           P2    access newFreeBAiocb = oldFreeBAiocb->BAiocbnext = @[I2]  F -> I1 -> I2 -> I3 ...
+                    **         |           P2     swap-remove I1,  place I2 at head of list                F -> I2 -> I3 ...
+                    **         |        P1       complete aio,  replace I0 at head of list                 F -> I0 -> I2 -> I3 ...
+                    **               P0        swap-remove I0,  place I1 at head of list                   F -> I1 IS IN USE !! CORRUPT !!
+                    **               compare-and-swap succeeded but the value of newFreeBAiocb was stale
+                    **               and had become in-use during the window.
+                    **        2.2    P0           access oldFreeBAiocb = BAiocbAnchr->FreeBAiocbs = @[I0]  F -> I0 -> I1 -> I2 -> I3 ...
+                    **               P0          access newFreeBAiocb = oldFreeBAiocb->BAiocbnext = @[I1]  F -> I0 -> I1 -> I2 -> I3 ...
+                    **         |        P1        access oldFreeBAiocb = BAiocbAnchr->FreeBAiocbs = @[I0]  F -> I0 -> I1 -> I2 -> I3 ...
+                    **         |        P1       access newFreeBAiocb = oldFreeBAiocb->BAiocbnext = @[I1]  F -> I0 -> I1 -> I2 -> I3 ...
+                    **         |        P1        swap-remove I0,  place I1 at head of list                F -> I1 -> I2 -> I3 ...
+                    **         |           P2     access oldFreeBAiocb = BAiocbAnchr->FreeBAiocbs = @[I1]  F -> I1 -> I2 -> I3 ...
+                    **         |           P2    access newFreeBAiocb = oldFreeBAiocb->BAiocbnext = @[I2]  F -> I1 -> I2 -> I3 ...
+                    **         |           P2     swap-remove I1,  place I2 at head of list                F -> I2 -> I3 ...
+                    **         |              P3  access oldFreeBAiocb = BAiocbAnchr->FreeBAiocbs = @[I2]  F -> I2 -> I3 ...
+                    **         |              P3 access newFreeBAiocb = oldFreeBAiocb->BAiocbnext = @[I3]  F -> I2 -> I3 ...
+                    **         |              P3  swap-remove I2,  place I3 at head of list                F -> I3 ...
+                    **         |           P2    complete aio,  replace I1 at head of list                 F -> I1 -> I3 ...
+                    **         |              P3 complete aio,  replace I2 at head of list                 F -> I2 -> I1 -> I3 ...
+                    **         |        P1       complete aio,  replace I0 at head of list                 F -> I0 -> I2 -> I1 -> I3 ...
+                    **               P0        swap-remove I0,  place I1 at head of list                   F -> I1 -> I3 ... ! I2 is orphaned !
+                    **               compare-and-swap succeeded but the value of newFreeBAiocb was stale
+                    **               and had moved further down the free list during the window.
+                    **      Unfortunately, we cannot prevent this pitfall but we can detect it (after the fact),
+                    **      by checking that the next pointer of the item we have just removed for our use still points to the same item.
+                    **      This test is not subject to any timing or uncertainty since :
+                    **       .  The fact that the compare-and-swap succeeded implies that the item we removed
+                    **          was defintely on the freelist (at the head) when it was removed,
+                    **          and therefore cannot be in use,  and therefore its next pointer is no longer volatile.
+                    **       .  Although pointers of the anchor and items on the freelist are volatile,
+                    **          the addresses of items never change -  they are in an allocated array and never move.
+                    **      E.g. in the above two scenarios,   the test is that I0.next still -> I1,
+                    **      and this is true if and only if the second item on the freelist is
+                    **      still the same at the end of the window as it was at the start of the window.
+                    **      Note that we do not insist that it did not change during the window,
+                    **           only that it is still the correct new head of freelist.
+                    **      If this test fails,  we abort immediately as the subsystem is damaged and cannot be repaired.
+                    **      Note that at least one aio must have been issued *and* completed during the window
+                    **           for this to occur,  and since the window is just one single machine instruction,
+                    **           it is very unlikely in practice.
+                    */
+                    BufferAiocbs = BAiocbAnchr->BufferAiocbs;
+                    remainder = ((long long int)oldFreeBAiocb - (long long int)BufferAiocbs)
+                                % (long long int)(sizeof(struct BufferAiocb));
+                    if (remainder == 0) {
+                        dividend = ((long long int)oldFreeBAiocb - (long long int)BufferAiocbs)
+                                    / (long long int)(sizeof(struct BufferAiocb));
+                    }
+                    if (    (remainder == 0)
+                         && ( (dividend >= 0 ) && ( dividend < numBufferAiocbs) )
+                       )
+                    {
+                        newFreeBAiocb = oldFreeBAiocb->BAiocbnext; /*  tentative new value is second on free list */
+                        /*   Here we are in the exposure window referred to in the above comments,
+                        **   so moving along rapidly ...
+                        */
+                        if (__sync_bool_compare_and_swap (&(BAiocbAnchr->FreeBAiocbs), oldFreeBAiocb, newFreeBAiocb)) {   /*  did we get it ? */
+                                /*   We have successfully swapped head of freelist pointed to by oldFreeBAiocb off the list;
+                                **   Here we check that the item we just placed at head of freelist, pointed to by newFreeBAiocb,
+                                **   is the right one
+                                **
+                                **   also check that the BAiocb we have acquired was not in use
+                                **   i.e. that scenario 2.1 above did not occur just before our compare-and-swap
+                                **   The test is that the BAiocb is not in use.
+                                **
+                                **  in one hypothetical case,
+                                **  we can be certain that there is no corruption -
+                                **  the case where newFreeBAiocb == 0 and oldFreeBAiocb->BAiocbnext != BAIOCB_OCCUPIED -
+                                **  i.e. we have set the freelist to empty but we have a baiocb chained from ours.
+                                **  in this case our comp_swap removed all BAiocbs from the list (including ours)
+                                **  so the others chained from ours are either orphaned (no harm done)
+                                **  or in use by another backend and will eventually be returned (fine).
+                                */
+                                if ((struct BufferAiocb *)0 == newFreeBAiocb) {
+                                    if ((struct BufferAiocb *)BAIOCB_OCCUPIED == oldFreeBAiocb->BAiocbnext) {
+                                        goto baiocb_corruption;
+                                    } else if ((struct BufferAiocb *)0 != oldFreeBAiocb->BAiocbnext) {
+                                      elog(LOG,
+                                         "AIO control block inconsistency on acquiring aiocb %p - its next free %p may be orphaned (no corruption has occurred)"
+                                         	,oldFreeBAiocb , oldFreeBAiocb->BAiocbnext);
+                                    }
+                                } else {
+                                    /*  case of newFreeBAiocb not null  -  so must check more carefully ... */
+                                    remainder = ((long long int)newFreeBAiocb - (long long int)BufferAiocbs)
+                                                % (long long int)(sizeof(struct BufferAiocb));
+                                    dividend = ((long long int)newFreeBAiocb - (long long int)BufferAiocbs)
+                                                / (long long int)(sizeof(struct BufferAiocb));
+
+                                    if (    (newFreeBAiocb != oldFreeBAiocb->BAiocbnext)
+                                         || (remainder != 0)
+                                         || ( (dividend < 0 ) || ( dividend >= numBufferAiocbs) )
+                                       ) {
+                                        goto baiocb_corruption;
+                                    }
+                                }
+                                BAiocb = oldFreeBAiocb;
+                                BAiocb->BAiocbnext = (struct BufferAiocb*)BAIOCB_OCCUPIED; /* mark as not on freelist */
+                                BAiocb->BAiocbDependentCount = 0;  /* no dependent yet */
+                                BAiocb->BAiocbbufh = (struct sbufdesc*)0;
+                                BAiocb->pidOfAio = 0;
+
+                                LockTries = 0;   /*  end the do loop  */
+
+                        }
+                    }
+
+                    if ( LockTries > 1 ) {
+                        sched_yield();    /*   yield to another process,  (hopefully a backend) */
+                    }
+                } while (     ((struct BufferAiocb*)0 == BAiocb)            /*  did not get a BAiocb    */
+                           && ((struct BufferAiocb*)0 != oldFreeBAiocb)     /*  there was a free BAiocb */
+                           && (LockTries-- > 0)                             /*  told to retry           */
+                        );
+            }
+        }
+
+        if ( BAiocb != (struct BufferAiocb*)0 ) {
+            /*  try an async io    */
+            BAiocb->BAiocbthis.aio_fildes = -1; /* necessary to ensure any thief realizes aio not yet started */
+            BAiocb->pidOfAio = this_backend_pid;
+
+            /*  now try to acquire a buffer :
+            **  note -   ReadBuffer_common returns hit=true if the block is found in the buffer pool,
+            **            in which case there is no need to prefetch.
+            **  otherwise ReadBuffer_common pins returned buffer and calls StartBufferIO
+            **           and StartBufferIO :
+            **      . sets buf_desc->freeNext to negative of ( index of the aiocb in the BufferAiocbs array + 3 )
+            **      . sets  BAiocb->BAiocbbufh -> buf_desc
+            **           and in this case the buffer spinlock is held.
+            **           This is essential as no other task must issue any intention with respect
+            **           to the buffer until we have started the aio_read.
+            **  Also note that ReadBuffer_common handles enlarging the ResourceOwner buffer list as needed
+            **       so I dont need to do that
+            */
+            buf_id = ReadBuffer_common(reln->rd_smgr, reln->rd_rel->relpersistence,
+                                        forkNum, blockNum
+                                       ,RBM_NOREAD_FOR_PREFETCH  /*  tells ReadBuffer not to do any read,  just alloc buf */
+                                       ,strategy , &hit , (FREENEXT_BAIOCB_ORIGIN - (BAiocb - (BAiocbAnchr->BufferAiocbs))));
+            buf_desc = &BufferDescriptors[buf_id-1];    /* find buffer descriptor */
+
+            /*  normally hit will be false as presumably it was not in the pool
+            **  when our caller looked - but it could be there now ...
+            */
+            if (hit) {
+                   /*   see earlier comments  -  we must abandon the prefetch */
+                   retcode = 1 + PrivateRefCount[buf_id];
+                   BAiocb->BAiocbbufh = (struct sbufdesc *)0; /* indicator that we must release the BAiocb before exiting */
+            } else
+            if (  (buf_id > 0) && ((BufferDesc *)0 != buf_desc) && (buf_desc == BAiocb->BAiocbbufh)  ) {
+                   /*   buff descriptor header lock should be held.
+                   **   However,  just to be safe ,   now validate that
+                   **   we are still the owner and no other task already stole it.
+                   */
+
+                   buf_desc->flags &= ~BM_AIO_PREFETCH_PIN_BANKED; /* ensure no banked pin */
+                   /*  there should not be any other pid waiting on this buffer
+                   **  so check both of BM_VALID and BM_PIN_COUNT_WAITER are not set
+                   */
+                   if (    ( !(buf_desc->flags & (BM_VALID|BM_PIN_COUNT_WAITER) ) )
+                        && (buf_desc->flags & BM_AIO_IN_PROGRESS)
+                        && ((FREENEXT_BAIOCB_ORIGIN - (BAiocb - (BAiocbAnchr->BufferAiocbs))) == buf_desc->freeNext) /* it is still mine */
+                        && (-1 == BAiocb->BAiocbthis.aio_fildes)   /* no thief stole it */
+                        && (0 == BAiocb->BAiocbDependentCount)     /* no dependent */
+                     ) {
+                        /*   we have an empty buffer for our use */
+
+                        BAiocb->BAiocbthis.aio_buf = (void *)(BufHdrGetBlock(buf_desc)); /* Location of actual buffer.  */
+
+                        /*   note - there is no need to register self as an dependent of BAiocb
+                        **   as we shall not unlock buf_desc before we free the BAiocb
+                        */
+
+                        /*   smgrstartaio retcode is returned in smgrstartaio_rc -
+                        **   it indicates whether started or not
+                        */
+#ifdef USE_AIO_SIGEVENT
+                        BAiocb->BAiocbaioOrdinal = BAiocbaioOrdinal;
+#endif /*  USE_AIO_SIGEVENT    */
+                        smgrstartaio(reln->rd_smgr, forkNum, blockNum , (char *)&(BAiocb->BAiocbthis) , &smgrstartaio_rc
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on signal instead of polling */
+                                    ,BAiocbaioOrdinal
+#endif /*  USE_AIO_SIGEVENT    */
+                                    );
+#if defined(USE_AIO_SIGEVENT)
+                        BAiocbaioOrdinal++;    /* ordinal of most recent aio originated by me */
+#endif /*  USE_AIO_SIGEVENT    */
+
+                        if (smgrstartaio_rc == 0) {
+                            retcode = 0;
+                            buf_desc->flags |= BM_AIO_PREFETCH_PIN_BANKED; /* bank the pin for next use by this task */
+                            /* we did not register register self as an dependent of BAiocb so no need to unregister  */
+                        } else {
+                            /*  failed - return the BufferAiocb to the free list  */
+                            do_unpin_buffer = true;    /* unpin must be deferred until after buffer descriptor is unlocked */
+                            /*  spinlock held so instead of TerminateBufferIO(buf_desc, false , 0); ... */
+                            buf_desc->flags &= ~(BM_IO_IN_PROGRESS | BM_IO_ERROR | BM_AIO_IN_PROGRESS | BM_AIO_PREFETCH_PIN_BANKED | BM_VALID);
+                            /* we did not register register self as an dependent of BAiocb so no need to unregister  */
+
+                            /*  return the BufferAiocb to the free list  */
+                            if (
+                                   BufReleaseAsync(BAiocb)
+                               ) {         /*  failed ? */
+                                BAiocb->BAiocbnext = cachedBAiocb;    /* then ...       */
+                                cachedBAiocb = BAiocb;                /*  ... cache it  */
+                            }
+
+                            pgBufferUsage.aio_read_failed++;
+                            smgrstartaio_rc = 1;  /*   to distinguish from aio not even attempted */
+                        }
+                   }
+                   else {
+                            /*  buffer was stolen or in use by other task - return the BufferAiocb to the free list  */
+                            do_unpin_buffer = true;    /* unpin must be deferred until after buffer descriptor is unlocked */
+                   }
+
+                   UnlockBufHdr(buf_desc);
+                   if (do_unpin_buffer) {
+                        if (smgrstartaio_rc >= 0) { /*  if  aio was attempted */
+                            TerminateBufferIO(buf_desc, false , 0);
+                        }
+                        UnpinBuffer(buf_desc, true);
+                   }
+            }
+            else {
+                BAiocb->BAiocbbufh = (struct sbufdesc *)0; /* indicator that we must release the BAiocb before exiting */
+            }
+
+            if ((struct sbufdesc*)0 == BAiocb->BAiocbbufh) { /*  we did not associate a buffer */
+                                                             /*  so return the BufferAiocb to the free list  */
+                            if (
+                                   BufReleaseAsync(BAiocb)
+                               ) {         /*  failed ? */
+                                BAiocb->BAiocbnext = cachedBAiocb;    /* then ...       */
+                                cachedBAiocb = BAiocb;                /*  ... cache it  */
+                            }
+            }
+        }
+    }
+
+    return retcode;
+
+    baiocb_corruption:;
+         elog(PANIC,
+              "AIO control block corruption on acquiring aiocb %p - its next free %p conflicts with new freelist pointer %p which may be invalid (corruption may have occurred)"
+                                                    ,oldFreeBAiocb , oldFreeBAiocb->BAiocbnext , newFreeBAiocb);
+}
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+
+/*
+ * BufCheckAsync --      act upon caller's intention regarding a shared buffer,
+ *                       primarily in connection with any async io in progress on the buffer.
+ *     class  subvalue   intention has two main classes and some subvalues within those :
+ *      +ve      1            .   want    <=>  caller wants the buffer,
+ *                                             wait for in-progress aio and then always pin
+ *      -ve                   .   reject  <=>  caller does not want the buffer,
+ *                                             if there are no dependents,  then cancel the aio
+ *              -1, -2 , -3 , ... (see below)        and then optionally unpin
+ *                             Used when there may have been a previous fetch or prefetch.
+ *
+ * buffer is assumed to be an existing member of the shared buffer pool
+ *    as returned by BufTableLookup.
+ * if AIO in progress,  then :
+ *      .  terminate AIO, waiting for completion if +ve intention, else without waiting
+ *      .  if the AIO had already completed successfully,   then mark buffer valid
+ *      .  pin/unpin as requested
+ *
+ * +ve intention indicates that buffer must be pinned :
+ *   if the strategy parameter is null,  then use the PinBuffer_Locked optimization
+ *   to pin and unlock in one operation.   But always update buffer usage count.
+ *
+ * -ve intention indicates whether and how to unpin :
+ *   BUF_INTENTION_REJECT_KEEP_PIN 	-1   pin already held, do not unpin, (caller wants to keep it)
+ *   BUF_INTENTION_REJECT_OBTAIN_PIN	-2   obtain pin,  caller wants it for same buffer
+ *   BUF_INTENTION_REJECT_FORGET	-3   unpin and tell resource owner to forget
+ *   BUF_INTENTION_REJECT_NOADJUST	-4   unpin and call ResourceOwnerForgetBuffer myself
+ *                                           instead of telling UnpinBuffer to adjust CurrentResource owner
+ *                                           (quirky simulation of ReleaseBuffer logic)
+ *   BUF_INTENTION_REJECT_UNBANK   	-5   unpin only if pin banked by caller
+ *   The behaviour for the -ve case is based on that of ReleaseBuffer, adding handling of async io.
+ *
+ * pin/unpin action must take account of whether this backend hold a "disposable" pin on the particular buffer.
+ * A "disposable" pin is a pin acquired by buffer manager without caller knowing, such as :
+ *      when required to safeguard an async AIO  -  pin can be held across multiple bufmgr calls
+ *      when required to safeguard waiting for an async AIO  -  pin acquired and released within this function
+ * if a disposable pin is held,   then :
+ *      if a new pin is requested,  the disposable pin must be retained (redeemed) and any flags relating to it unset
+ *      if an unpin is requested,   then :
+ *              if    either no AIO in progress or this backend did not initiate the AIO
+ *              then  the disposable pin must be dropped (redeemed) and any flags relating to it unset
+ *              else  log warning and do nothing
+ *  i.e. in either case,   there is no longer a disposable pin after this function has completed.
+ *       Note that if    intention is BUF_INTENTION_REJECT_UNBANK,
+ *                 then caller expects there to be a disposable banked pin
+ *                      and if there isn't one,  we do nothing
+ *                 for all other intentions,  if there is no disposable pin,   we pin/unpin normally.
+ *
+ * index_for_aio indicates the BAiocb to be used for next aio (see PrefetchBuffer)
+ * BufFreelistLockHeld indicates whether freelistlock is held
+ * spinLockHeld indicates whether buffer header spinlock is held
+ * PartitionLock is the  buffer partition lock to be used
+ *
+ * return code (meaningful ONLY if intention is +ve) indicates validity of buffer :
+ *  -1    buffer is invalid and failed PageHeaderIsValid check
+ *   0    buffer is not valid
+ *   1    buffer is valid
+ *   2    buffer is valid but tag changed  -  (so content does not match the relation block that caller expects)
+ */
+int
+BufCheckAsync(SMgrRelation caller_smgr, Relation caller_reln, BufferDesc volatile * buf_desc, int intention , BufferAccessStrategy strategy , int index_for_aio , bool spinLockHeld , LWLockId PartitionLock )
+{
+
+        int retcode = BUF_INTENT_RC_INVALID_NO_AIO;
+        bool valid = false;
+
+
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+        int smgrcompleteaio_rc;          /*  retcode from smgrcompleteaio */
+        SMgrRelation smgr = caller_smgr;
+        int    		BAiocbDependentCount_after_aio_finished = -1;  /*  for debugging  -  can be printed in gdb */
+	    BufferTag origTag = buf_desc->tag;	/* original identity of selected buffer */
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+        BufFlags	flags_on_entry;  /*  for debugging  -  can be printed in gdb */
+        int    		freeNext_on_entry;  /*  for debugging  -  can be printed in gdb */
+        bool       disposable_pin = false;            /* this backend had a disposable pin on entry or pins the buffer while waiting for aio_read to complete */
+        bool       pin_already_banked_by_me;          /* buffer is already pinned by me and redeemable */
+
+        int aio_successful = -1;         /*  did the aio_read succeed ?  -1 = no aio,  0 unsuccessful , 1 successful */
+        int local_intention = intention; /*  copy of intention which in one special case below may be set differently to intention */
+
+            if (!spinLockHeld) {
+                /*  lock buffer header    */
+                LockBufHdr(buf_desc);
+            }
+
+	    flags_on_entry = buf_desc->flags;
+	    freeNext_on_entry = buf_desc->freeNext;
+            pin_already_banked_by_me =
+                      (    (flags_on_entry & BM_AIO_PREFETCH_PIN_BANKED)
+                        && (   (    (flags_on_entry & BM_AIO_IN_PROGRESS) ? ( ((BAiocbAnchr->BufferAiocbs)+(FREENEXT_BAIOCB_ORIGIN - freeNext_on_entry))->pidOfAio )
+                                                                      : (-(freeNext_on_entry))  )  == this_backend_pid )
+                      );
+
+            if (pin_already_banked_by_me) {
+                if (PrivateRefCount[buf_desc->buf_id] == 0) {  /*  but do we actually have a pin ?? */
+                    /*   this is an anomalous situation   -  somehow our disposable pin was lost without us noticing
+                    **   if AIO is in progress and we started it,
+                    **   then this is disastrous  -   two backends might both issue IO on same buffer
+                    **   otherwise,  it is harmless,  and simply means we have no disposable pin,
+                    **               but we must update flags to "notice" the fact now
+                    */
+                    if (flags_on_entry & BM_AIO_IN_PROGRESS) {
+                            elog(ERROR, "BufCheckAsync : AIO control block issuer of aio_read lost pin with BM_AIO_IN_PROGRESS on buffer %d rel=%s, blockNum=%u, flags 0x%X refcount=%u intention= %d"
+                                ,buf_desc->buf_id,relpathbackend(buf_desc->tag.rnode, InvalidBackendId, buf_desc->tag.forkNum)
+                           ,buf_desc->tag.blockNum, flags_on_entry, buf_desc->refcount ,intention);
+                    } else {
+                            elog(LOG, "BufCheckAsync : AIO control block issuer of aio_read lost pin on buffer %d rel=%s, blockNum=%u, with flags 0x%X refcount=%u intention= %d"
+                               ,buf_desc->buf_id,relpathbackend(buf_desc->tag.rnode, InvalidBackendId, buf_desc->tag.forkNum)
+                               ,buf_desc->tag.blockNum, flags_on_entry, buf_desc->refcount ,intention);
+							buf_desc->flags &= ~BM_AIO_PREFETCH_PIN_BANKED; /*   redeem the banked pin  */
+							/*   since AIO not in progress,  disconnect the buffer from banked pin */
+							buf_desc->freeNext = FREENEXT_NOT_IN_LIST;      /*   and forget the bank client */
+							pin_already_banked_by_me = false;
+                    }
+                } else {
+                    disposable_pin = true;
+                }
+            }
+
+            /*  the case of BUF_INTENTION_REJECT_UNBANK is handled specially :
+            **    if this backend has a banked pin,  then proceed just as for BUF_INTENTION_REJECT_FORGET
+            **    else the call is a no-op  --  unlock buf header and return immediately
+            */
+
+            if (intention == BUF_INTENTION_REJECT_UNBANK) {
+                if (pin_already_banked_by_me) {
+                    local_intention = BUF_INTENTION_REJECT_FORGET;
+                } else {
+                    goto unlock_buf_header;  /*  code following the unlock will do nothing since local_intention still set to BUF_INTENTION_REJECT_UNBANK */
+                }
+            }
+
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+            /*       we do not expect that BM_AIO_IN_PROGRESS is set without freeNext identifying the BAiocb */
+            if ( (buf_desc->flags & BM_AIO_IN_PROGRESS) && (buf_desc->freeNext == FREENEXT_NOT_IN_LIST) ) {
+
+					elog(ERROR, "BufCheckAsync : found BM_AIO_IN_PROGRESS without a BAiocb on buffer %d rel=%s, blockNum=%u, flags %X refcount=%u"
+						,buf_desc->buf_id,relpathbackend(buf_desc->tag.rnode, InvalidBackendId, buf_desc->tag.forkNum)
+						,buf_desc->tag.blockNum, buf_desc->flags, buf_desc->refcount);
+                }
+            /*     check whether aio in progress  */
+            if  (    ( (struct BAiocbAnchor *)0 != BAiocbAnchr )
+                  && (buf_desc->flags & BM_AIO_IN_PROGRESS)
+                  && (buf_desc->freeNext <= FREENEXT_BAIOCB_ORIGIN)                       /*  has a valid BAiocb */
+                  && ((FREENEXT_BAIOCB_ORIGIN - buf_desc->freeNext) < numBufferAiocbs)    /*  double-check */
+                ) {        /* this is aio   */
+                    struct BufferAiocb volatile * BAiocb = (BAiocbAnchr->BufferAiocbs)+(FREENEXT_BAIOCB_ORIGIN - buf_desc->freeNext); /*  BufferAiocb associated with this aio */
+                    if ((struct BufferAiocb*)BAIOCB_OCCUPIED == BAiocb->BAiocbnext) { /*  ensure BAiocb is occupied */
+                        aio_successful = 0;       /*  tentatively the aio_read did not succeed   */
+                        retcode = BUF_INTENT_RC_INVALID_AIO;
+
+                        if (smgr == NULL) {
+                            if (caller_reln == NULL) {
+                                smgr = smgropen(buf_desc->tag.rnode, InvalidBackendId);
+                            } else {
+                                smgr = caller_reln->rd_smgr;
+                            }
+                        }
+
+                        /*  assert that this AIO is not using the same BufferAiocb as the one caller asked us to use */
+                        if ((index_for_aio < 0) && (index_for_aio == buf_desc->freeNext)) {
+                                   ereport(ERROR,
+                                        (errcode(ERRCODE_INTERNAL_ERROR),
+                                         errmsg("AIO control block index %d to be used by %p already in use by %p"
+                                                  ,index_for_aio, buf_desc, BAiocb->BAiocbbufh)));
+                        }
+
+                        /*    Call smgrcompleteaio only if either we want buffer or there are no dependents.
+                        **    In the other case of reject and there are dependents,
+                        **    then one of them will do it.
+                        */
+                        if (   (local_intention > 0) || (0 == BAiocb->BAiocbDependentCount)  ) {
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on signal instead of polling */
+                            int cancelled = 0;                 /* is io to be cancelled ? */
+#endif /*  USE_AIO_SIGEVENT    */
+                            if (local_intention > 0) {
+                                /*  wait for in-progress aio and then pin
+                                **  OR  if I did not issue the aio and do not have a pin
+                                **  then pin now before waiting to ensure the buffer does not become unpinned while I wait
+                                **  we may potentially wait for io to complete
+                                **  so release buf header lock so that others may also wait here
+                                */
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on signal instead of polling */
+                                smgrcompleteaio_rc = 16;
+                                while (!(PoorMIncr(&(BAiocb->BAiocbDependentCount)))) { /* register self as dependent  */
+                                    if (smgrcompleteaio_rc--) {
+                                        elog(LOG, "BufCheckAsync : yielding %d to increment BAiocb %p dependent",smgrcompleteaio_rc,BAiocb);
+                                    }
+                                    sched_yield();
+                                }
+#else
+                                BAiocb->BAiocbDependentCount++; /* register self as dependent  */
+#endif /* USE_AIO_SIGEVENT  */
+                                if (PrivateRefCount[buf_desc->buf_id] == 0) {   /* if this buffer not pinned by me */
+                                    disposable_pin = true; /* this backend has pinned the buffer while waiting for aio_read to complete */
+                                    PinBuffer_Locked(buf_desc);
+                                } else {
+                                    UnlockBufHdr(buf_desc);
+                                }
+                                LWLockRelease(PartitionLock);
+
+                                smgrcompleteaio_rc = 1   /*  tell smgrcompleteaio to wait  */
+                                                   + ( BAiocb->pidOfAio == this_backend_pid ); /*  and whether I initiated the aio */
+                            } else {
+                                smgrcompleteaio_rc = 0;   /*  tell smgrcompleteaio to cancel */
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on signal instead of polling */
+            /*   because aio is to be cancelled , remember to post suspended waiters after, because no signal will be sent */
+                                cancelled = 1;
+#endif /*  USE_AIO_SIGEVENT    */
+                            }
+
+                            smgrcompleteaio( smgr , (char *)&(BAiocb->BAiocbthis) , &smgrcompleteaio_rc
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on signal instead of polling */
+                                           , ((int (*)(char *))(&BufAWaitAioCompletion))
+                                           , ((char *)BAiocb)
+#endif /*  USE_AIO_SIGEVENT    */
+                                           );
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on signal instead of polling */
+            /*   if aio was cancelled , then post suspended waiters because no signal will be sent */
+                            if (cancelled) {
+                                BufPostAioWaiters(BAiocb);
+                            }
+#endif /*  USE_AIO_SIGEVENT    */
+                            if ( (smgrcompleteaio_rc == 0) || (smgrcompleteaio_rc == 1) ) {
+                                  aio_successful = 1;
+                            }
+
+                            /*   statistics  */
+                            if (local_intention > 0) {
+                                if (smgrcompleteaio_rc == 0) {
+                                    /*    completed successfully and did not have to wait  */
+                                    pgBufferUsage.aio_read_ontime++;
+                                } else if (smgrcompleteaio_rc == 1) {
+                                    /*    completed successfully and did have to wait  */
+                                    pgBufferUsage.aio_read_waited++;
+                                } else {
+                                    /*  bad news   -   read failed and so buffer not usable
+                                    **  the buffer is still pinned so unpin and proceed with "not found" case
+                                    */
+                                    pgBufferUsage.aio_read_failed++;
+                                }
+
+                                /*  regain locks and handle the validity of the buffer and intention regarding it    */
+                                LWLockAcquire(PartitionLock, LW_SHARED);
+                                LockBufHdr(buf_desc);
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on signal instead of polling */
+                                smgrcompleteaio_rc = 16;
+                                while (!(PoorMDecr(&(BAiocb->BAiocbDependentCount)))) { /* unregister self as dependent  */
+                                    if (smgrcompleteaio_rc--) {
+                                        elog(LOG, "BufCheckAsync : yielding %d to decrement BAiocb %p dependent",smgrcompleteaio_rc,BAiocb);
+                                    }
+                                    sched_yield();
+                                }
+#else
+                                BAiocb->BAiocbDependentCount--; /* unregister self as dependent  */
+#endif /* USE_AIO_SIGEVENT  */
+                            } else {
+                                    pgBufferUsage.aio_read_wasted++;  /*   regardless of whether aio_successful */
+                            }
+
+
+                            if (local_intention > 0) {
+                                /*  verify the buffer is still ours and has same identity
+                                **  There is one slightly tricky point here -
+                                **  if there are other dependents,   then each of them will perform this same check
+                                **  this is unavoidable as the correct setting of retcode and the BM_VALID flag
+                                **  is required by each dependent,  so we may not leave it to the last one to do it.
+                                **  It should not do any harm and easier to let them all do it than try to avoid.
+                                */
+                                if ((FREENEXT_BAIOCB_ORIGIN - (BAiocb - (BAiocbAnchr->BufferAiocbs))) == buf_desc->freeNext) { /* it is still mine */
+
+                                    if (aio_successful) {
+                                        /* validate page header.   If valid,  then mark the buffer as valid */
+                                        if (PageIsVerified((Page)(BufHdrGetBlock(buf_desc)) , ((BAiocb->BAiocbthis).aio_offset/BLCKSZ))) {
+                                            buf_desc->flags |= BM_VALID;
+                                            if (BUFFERTAGS_EQUAL(origTag , buf_desc->tag)) {
+                                                retcode = BUF_INTENT_RC_VALID;
+                                            } else {
+                                                retcode = BUF_INTENT_RC_CHANGED_TAG;
+                                            }
+                                        } else {
+                                            retcode = BUF_INTENT_RC_BADPAGE;
+                                        }
+                                    }
+                                }
+                            }
+
+                            BAiocbDependentCount_after_aio_finished = BAiocb->BAiocbDependentCount;
+
+                            /*  if no dependents,   then disconnect the BAiocb and update buffer header */
+                            if (BAiocbDependentCount_after_aio_finished == 0 ) {
+
+                                /*  return the BufferAiocb to the free list  */
+                                buf_desc->flags &= ~(BM_IO_IN_PROGRESS | BM_IO_ERROR | BM_AIO_IN_PROGRESS);
+
+                                if (
+                                           BufReleaseAsync(BAiocb)
+                                   ) {        /*  failed ? */
+                                    BAiocb->BAiocbnext = cachedBAiocb;   /* then ...       */
+                                    cachedBAiocb = BAiocb;               /*  ... cache it  */
+                                }
+                            }
+
+                        }
+                    }
+            }         /* end this is aio   */
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+
+            /*  At this point,  buffer header spinlock is held in all cases.
+            **  1.  it was either acquired by caller and held on entry or we acquired at early in this function
+            **  2.  if  (local_intention <= 0) it was never released
+            **  3.  if  (local_intention >  0) it was released and re-acquired around the call to smgrstartaio
+            */
+            /*  note whether buffer is valid before unlocking spinlock */
+            valid = ((buf_desc->flags & BM_VALID) != 0);
+
+            /*  if there was a disposable pin on entry to this function (i.e. marked in buffer flags)
+            **  then unmark it  -  refer to prologue comments talking about :
+            **    if a disposable pin is held,   then :
+            **     ...
+            **    i.e. in either case,   there is no longer a disposable pin after this function has completed.
+            */
+            if (pin_already_banked_by_me) {
+                        buf_desc->flags &= ~BM_AIO_PREFETCH_PIN_BANKED; /*   redeem the banked pin  */
+                        /*   if AIO not in progress,  then disconnect the buffer from BAiocb and/or banked pin */
+                        if (!(buf_desc->flags & BM_AIO_IN_PROGRESS)) {
+                            buf_desc->freeNext = FREENEXT_NOT_IN_LIST;      /*   and forget the bank client */
+                        }
+                        /********** for debugging   *****************
+                        else elog(LOG, "BufCheckAsync : found BM_AIO_IN_PROGRESS when redeeming banked pin on buffer %d rel=%s, blockNum=%u, flags %X refcount=%u"
+                       ,buf_desc->buf_id,relpathbackend(buf_desc->tag.rnode, InvalidBackendId, buf_desc->tag.forkNum)
+                       ,buf_desc->tag.blockNum, buf_desc->flags, buf_desc->refcount);
+                        ********** for debugging     *****************/
+            }
+
+            /*  If we are to obtain new pin, then use pin optimization  -  pin and unlock.
+            **  However,   if the caller is the same backend who issued the aio_read,
+            **  then he ought to have obtained the pin at that time and must not acquire
+            **  a "second" one since this is logically the same read -  he would have obtained
+            **  a single pin if using synchronous read and we emulate that behaviour.
+            **  Its important to understand that the caller is not aware that he already obtained a pin -
+            **  because calling PrefetchBuffer did not imply a pin -
+            **  so we must track that via the pidOfAio field in the BAiocb.
+            **  And to add one further complication :
+            **      we assume that although PrefetchBuffer pinned the buffer,
+            **      it did not increment the usage count.
+            **      (because it called PinBuffer_Locked which does not do that)
+            **      so in this case,   we must increment the usage count without double-pinning.
+            **      yes its ugly  -  and theres a goto!
+            */
+            if (   (local_intention > 0)
+                || (local_intention == BUF_INTENTION_REJECT_OBTAIN_PIN)
+               ) {
+
+                /* Make sure we will have room to remember the buffer pin */
+                ResourceOwnerEnlargeBuffers(CurrentResourceOwner);
+
+                /*    here we really want a version of PinBuffer_Locked which updates usage count ... */
+                if (   (PrivateRefCount[buf_desc->buf_id] == 0) /*   if this buffer not previously pinned by me */
+                    || pin_already_banked_by_me                 /*   or I had a disposable pin on entry */
+                   ) {
+                    if (strategy == NULL)
+                    {
+                            if (buf_desc->usage_count < BM_MAX_USAGE_COUNT)
+                                    buf_desc->usage_count++;
+                    }
+                    else
+                    {
+                            if (buf_desc->usage_count == 0)
+                                    buf_desc->usage_count = 1;
+                    }
+                }
+
+                /*  now pin buffer unless we have a disposable */
+                if (!disposable_pin) { /* this backend neither banked pin for aio nor pinned the buffer while waiting for aio_read to complete */
+                    PinBuffer_Locked(buf_desc);
+                    goto unlocked_it;
+                }
+                else
+                /*    if this task previously issued the aio or pinned the buffer while waiting for aio_read to complete
+                **       and aio was unsuccessful,    then release the pin
+                */
+                if (     disposable_pin
+                      && (aio_successful == 0)       /*  aio_read failed ? */
+                   ) {
+                    UnlockBufHdr(buf_desc);    /*  release spinlock since UnpinBuffer acquires it -  annoying but infrequent case */
+                    UnpinBuffer(buf_desc, true);
+                    goto unlocked_it;
+                }
+            }
+
+    unlock_buf_header:
+            UnlockBufHdr(buf_desc);
+    unlocked_it:
+
+            /*   now do any requested pin (if not done immediately above) or unpin/forget  */
+            if (local_intention == BUF_INTENTION_REJECT_KEEP_PIN) {
+            /*   the caller is supposed to hold a pin already so there should be nothing to do ... */
+                if (PrivateRefCount[buf_desc->buf_id] == 0) {
+                    elog(LOG, "request to keep pin on unpinned buffer %d",buf_desc->buf_id);
+
+                    valid = PinBuffer(buf_desc, strategy);
+                }
+            }
+            else
+            if (   (   (local_intention == BUF_INTENTION_REJECT_FORGET)
+                    || (local_intention == BUF_INTENTION_REJECT_NOADJUST)
+                   )
+                && (PrivateRefCount[buf_desc->buf_id] > 0) /*   if this buffer was previously pinned by me ... */
+               )  {
+
+                    if (local_intention == BUF_INTENTION_REJECT_FORGET) {
+                        UnpinBuffer(buf_desc, true); /*  ... then release the pin                   */
+                    } else
+                    if (local_intention == BUF_INTENTION_REJECT_NOADJUST) {
+                        /*   following code moved from ReleaseBuffer :
+                        **   not sure why we can't simply UnpinBuffer(buf_desc, true)
+                        **   but better leave it the way it was
+                        */
+                        ResourceOwnerForgetBuffer(CurrentResourceOwner, BufferDescriptorGetBuffer(buf_desc));
+                        if (PrivateRefCount[buf_desc->buf_id] > 1) {
+                            PrivateRefCount[buf_desc->buf_id]--;
+                        } else {
+                            UnpinBuffer(buf_desc, false);
+                        }
+                    }
+            }
+
+            /*    if retcode has not been set to one of the unusual conditions
+            **        namely failed header validity or tag changed
+            **    then the setting of valid takes precedence
+            **    over whatever retcode may be currently set to.
+            */
+            if ( ( (retcode == BUF_INTENT_RC_INVALID_NO_AIO) || (retcode == BUF_INTENT_RC_INVALID_AIO) ) && valid) {
+                   retcode = BUF_INTENT_RC_VALID;
+            } else
+            if ((retcode == BUF_INTENT_RC_VALID) && (!valid)) {
+                   if (aio_successful == -1) { /* aio not attempted */
+                       retcode = BUF_INTENT_RC_INVALID_NO_AIO;
+                   } else {
+                       retcode = BUF_INTENT_RC_INVALID_AIO;
+                   }
+            }
+
+            return retcode;
+}
+
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on signal instead of polling */
+
+/*   PoorMans Atomic functions :
+**   these functions operate on a signed int as follows :
+**   suppose current value of int is v
+**       .  lock       if v >  0 then compswap int to -v else fail
+**       .  unlock     if v <  0 then compswap int to -v (i.e. abs(v)) else fail
+**       .  increment  if v >= 0 then compswap int to (v+1) else fail
+**       .  decrement  if v >  0 then compswap int to (v-1) else fail
+**
+**   thus the lock prevents int from being incremented or decremented
+**
+**   in all cases :
+**      there is no retrying within PoorMan,  caller must do so if desired
+**      return return code from either test as described above or from compswap
+**              ( non-zero <=> success , 0 <=> fail )
+**      although not policed,  caller who gets lock should release it very soon after
+**                             and should not wait in any way while lock is held.
+*/
+
+static int PoorMLock(volatile int *intP) {
+     int rc = *intP;
+     if (rc > 0) {
+         rc = (__sync_bool_compare_and_swap (intP, rc, (-rc))); /* swap to -ve */
+     } else {
+         rc = 0; /* fail */
+     }
+     return rc;
+}
+
+static int PoorMUnLock(volatile int *intP) {
+     int rc = *intP;
+     if (rc < 0) {
+         rc = (__sync_bool_compare_and_swap (intP, rc, (-rc))); /* swap to +ve */
+     } else {
+         rc = 0; /* fail */
+     }
+     return rc;
+}
+
+static int PoorMIncr(volatile int *intP) {
+     int rc = *intP;
+     if (rc >= 0) {
+         rc = (__sync_bool_compare_and_swap (intP, rc, (rc+1))); /* swap to v+1 */
+     } else {
+         rc = 0; /* fail */
+     }
+     return rc;
+}
+
+static int PoorMDecr(volatile int *intP) {
+     int rc = *intP;
+     if (rc > 0) {
+         rc = (__sync_bool_compare_and_swap (intP, rc, (rc-1))); /* swap to v-1 */
+     } else {
+         rc = 0; /* fail */
+     }
+     return rc;
+}
+
+/*  the following functions break the smgr / md / fd layering by calling aio_error directly
+**  but this is a lesser evil than locating them in fd.c since they refer heavily to
+**  buffer-manager async-io signalling/completion constructs.
+*/
+#include "aio.h"
+/*  post backends waiting on BAiocb
+**  may be called either from signal-handler context or from mainline context
+*/
+void
+BufPostAioWaiters(struct BufferAiocb volatile * BAiocb)
+{
+      int cs_rc;
+	  volatile struct PGPROC *BAiocbWaiterProc;	    /* backend waiting for aio completion */
+	  volatile struct PGPROC *BAiocbWaiterProcnext;	/* next backend waiting for aio completion */
+
+          cs_rc = PoorMLock( &(BAiocb->BAiocbDependentCount) ); /* lock the BAiocb dependents */
+          if (cs_rc) { /* locked?  note locked implies BAiocbDependentCount was > 0 */
+              /*  check whether actually complete and get status.
+              **  The correct method is to call smgrcompleteaio
+              **  but that function might wait which we must not do,
+              **  so we must call aio_error directly and bypass the layers.
+              */
+              cs_rc = aio_error((const struct aiocb *)(&(BAiocb->BAiocbthis)));
+              if (cs_rc != EINPROGRESS) { /* any rc other than EINPROGRESS implies it is not in progress */
+                  /*  run the chain and wake up any waiters */
+                  /*  note - waiter may be me,  in which case omit sending another signal.
+                  */
+                  BAiocbWaiterProc = BAiocb->BAiocbWaiterchain;          /* current head of chain */
+                  while (BAiocbWaiterProc != (struct PGPROC *)0) {        /*  not reached end */
+                      BAiocbWaiterProcnext = BAiocbWaiterProc->BAiocbWaiterLink;
+                      cs_rc = (__sync_bool_compare_and_swap (&(BAiocb->BAiocbWaiterchain), BAiocbWaiterProc, BAiocbWaiterProcnext)); /* swap it off chain */
+                      if (cs_rc) {
+                          if (this_backend_pid != BAiocbWaiterProc->pid) {
+                              kill(BAiocbWaiterProc->pid , AIO_SIGEVENT_SIGNALNUM);
+                          }
+                          BAiocbWaiterProc = BAiocb->BAiocbWaiterchain;   /* new head of chain */
+                      } else {
+                          elog(LOG, "BufPostAioWaiters : my pid %d unable to remove waiter pid %d from BAiocb %p dept count= %d"
+                                    ,this_backend_pid,BAiocbWaiterProc->pid,BAiocb,BAiocb->BAiocbDependentCount);
+                          break; /* abandon ship if we could not swap it off cleanly */
+                      }
+                  }
+              }
+              /*  whatever else we achieve,  we *must* unlock the BAiocbDependentCount
+              **  it would be a bug if the following PoorMUnLock fails
+              **  since no other process can modify it while locked,
+              **  but we must check that.
+              */
+              cs_rc = PoorMUnLock( &(BAiocb->BAiocbDependentCount) ); /* unlock the BAiocb dependents */
+              while (!cs_rc) {
+                  sched_yield();
+                  cs_rc = PoorMUnLock( &(BAiocb->BAiocbDependentCount) ); /* unlock the BAiocb dependents */
+              }
+          }
+}
+/*   handle the AIO SIGNAL sent by kernel and by other backend for a completion.
+**    .  if sent by other backend,  then do nothing as the sole purpose is to wake me up
+**    .  if sent by kernel as a result of a sigqueue by aio completion, then :
+**         for each BAiocb,
+**           poor-man lock the BAiocb against change in dependents (including being released),
+**           check if io is complete (successful or otherwise)
+**           then check if there are any waiters and if so signal them.
+**           Note  -  logically,   each backend should operate on only BAiocbs associated with
+**                    ios which that same backend originated;
+**                    However,   there is no reason to insist on being originated by me,
+**                    and a potential benefit from not doing so in that we may
+**                    post a waiter sooner,  so simply check all.
+**           Retort - experimentally it seems that only posting waiters waiting on aio I originated is better
+*/
+void BufHandlSigAsync(int sigsent, siginfo_t * siginfP, void *ucontext)
+{
+      volatile struct BufferAiocb *BufferAiocbs;
+	  volatile struct BufferAiocb *BAiocb;	/*  this BAiocb */
+      int ix;
+
+      if (sigsent == AIO_SIGEVENT_SIGNALNUM) {                                     /*  related to aio completion ... */
+          if ( (siginfP != (siginfo_t *)0) && (siginfP->si_code == SI_ASYNCIO) ) { /* ... from sigqueue */
+              BufferAiocbs = BAiocbAnchr->BufferAiocbs;    /*  address base of the BAiocbs */
+              __sync_fetch_and_add (&num_signalledaio, 1); /*  accounting */
+              for (ix = (numBufferAiocbs-1);  ix>=0;  ix--) {
+                  BAiocb = (BufferAiocbs+ix);	/*  this BAiocb */
+#ifndef AIO_PRIMISCUOUS_POSTING
+                  /*  post only if this aio was originated by me
+                  **  no later than the one to which this signal applies
+                  */
+                  if ( (BAiocb->pidOfAio == this_backend_pid) && (BAiocb->BAiocbaioOrdinal <= (unsigned long)(siginfP->si_value.sival_ptr)) )
+#endif /*  AIO_PRIMISCUOUS_POSTING */
+                  BufPostAioWaiters(BAiocb);
+              }
+          }
+      }
+}
+
+/*  function to await completion if non-originator
+*   called as a callback from FileCompleteaio
+*   returns the aio_error return code from completion
+*/
+extern sigset_t blockaiosighandlrmask; /* defined in buf_init.c */
+int BufAWaitAioCompletion (struct BufferAiocb *BAiocb) /* pointer to BAIOcb  */ 
+{
+
+    int onwaitchain = 0;              /*  is my PROC on the waiter chain ? */
+	int	aio_errno;
+    struct aiocb volatile * my_aiocbp = &(BAiocb->BAiocbthis);
+    struct PGPROC volatile ** BAiocbWaiterchainP = &(BAiocb->BAiocbWaiterchain); /* anchor of chain of backends waiting for aio completion */
+    struct PGPROC * FirstWaiterProc; /* PROC of first backend waiting for aio completion */
+    sigset_t tempmask;
+    volatile struct PGPROC *BAiocbWaiterProc;	    /* backend waiting for aio completion */
+	volatile struct PGPROC *BAiocbWaiterProcnext;	/* next backend waiting for aio completion */
+
+        sigprocmask(SIG_BLOCK,&blockaiosighandlrmask,&tempmask); /*  temporarily block signal AIO_SIGEVENT_SIGNALNUM */
+        aio_errno = aio_error((const struct aiocb *)my_aiocbp);
+        while (aio_errno == EINPROGRESS) {              /*  check still in progress */
+            if (!onwaitchain) {
+                /*  place self on chain of waiters  */
+                FirstWaiterProc = (struct PGPROC *)(*BAiocbWaiterchainP);  /*  dereference current head of chain */
+                MyProc->BAiocbWaiterLink = FirstWaiterProc;            /*  and attach this current chain to mine */
+                onwaitchain = __sync_bool_compare_and_swap (BAiocbWaiterchainP, FirstWaiterProc, MyProc); /* swap it onto chain */
+                if (onwaitchain) {                               /*   successfully swapped onto chain */
+                    sigsuspend(&tempmask);                       /*   unblock signal AIO_SIGEVENT_SIGNALNUM and wait for it */
+                } else {
+                    /*  failed to place myself on waiter chain so yield and try again */
+                    sigprocmask(SIG_SETMASK,&tempmask,0);            /*  normal mask allows AIO_SIGEVENT_SIGNALNUM */
+                    sched_yield();
+                    sigprocmask(SIG_BLOCK,&blockaiosighandlrmask,&tempmask); /*  temporarily block signal AIO_SIGEVENT_SIGNALNUM again */
+                }
+            }
+            aio_errno = aio_error((const struct aiocb *)my_aiocbp);                             /* and check once again */
+        }
+        sigprocmask(SIG_SETMASK,&tempmask,0);            /*  restore original mask which allows AIO_SIGEVENT_SIGNALNUM */
+
+        /*  ensure my PROC is no longer on wait chain -
+        *   signal-handler may or may not have done so.
+        *   note there is no race condition with sig handler
+        *        because sig handler swaps the PROC off the waiter chain *before* signalling me
+        */
+        while (onwaitchain) {                               /*   successfully swapped onto chain */
+            onwaitchain = 0;              /*  tentatively my PROC is no longer on the waiter chain */
+            BAiocbWaiterProc = BAiocb->BAiocbWaiterchain;          /* current head of chain */
+            while (BAiocbWaiterProc != (struct PGPROC *)0) {        /*  not reached end */
+                BAiocbWaiterProcnext = BAiocbWaiterProc->BAiocbWaiterLink;
+                if (BAiocbWaiterProc == MyProc) {  /*  is this me ? */
+                    onwaitchain = ( (__sync_bool_compare_and_swap (&(BAiocb->BAiocbWaiterchain), BAiocbWaiterProc, BAiocbWaiterProcnext)) /* swap it off chain */
+                                    ? 0  /*  my PROC is no longer on the waiter chain */
+                                    : 1  /*  my PROC is on the waiter chain */
+                    );
+                }
+                BAiocbWaiterProc = BAiocbWaiterProcnext;
+            }
+        }
+
+        return aio_errno;
+}
+#endif /*  USE_AIO_SIGEVENT    */
